<template>
	<div class="matrix-info lightorange-color" :class="{assigned : matrix.assigned_vairus}" v-on:click.self="$emit('closematrixinfo')">
		<div class="inner orange-gradient">
			<div class="container">
				<div class="header flex space">
					<div class="node" v-tooltip2="'LV'+matrix.level">
						<svg xmlns="http://www.w3.org/2000/svg" width="80" height="80"  viewBox="-2 -2 84 84">
							<defs>
								<filter id="box-shadow" filterUnits="userSpaceOnUse">
									<feOffset result="offOut" in="SourceGraphic" dx="0" dy="0" />
									<feGaussianBlur result="blurOut" in="offOut" stdDeviation="2" />
									<feBlend in="SourceGraphic" in2="blurOut" mode="normal" />
								</filter>
							</defs>
							
							<path d="M 35 3 L 46 14 M 35 3 L 24 14"   :filter="(matrix.level > 0)? 'url(#box-shadow)' : 'none'" :stroke-width="(matrix.level > 0) ? 6 : 1" stroke-linecap="square" stroke="#FFC233" fill="none"></path>
							<path d="M 67 35 L 56 24 M 67 35 L 56 46" :filter="(matrix.level > 1)? 'url(#box-shadow)' : 'none'" :stroke-width="(matrix.level > 1) ? 6 : 1" stroke-linecap="square" stroke="#FFC233" fill="none"></path>
							<path d="M 35 67 L 24 56 M 35 67 L 46 56" :filter="(matrix.level > 2)? 'url(#box-shadow)' : 'none'" :stroke-width="(matrix.level > 2) ? 6 : 1" stroke-linecap="square" stroke="#FFC233" fill="none"></path>
							<path d="M 3 35 L 14 46 M 3 35 L 14 24"   :filter="(matrix.level > 3)? 'url(#box-shadow)' : 'none'" :stroke-width="(matrix.level > 3) ? 6 : 1" stroke-linecap="square" stroke="#FFC233" fill="none"></path>
						</svg>
					
						<div class="inner">
							<div class="favicon" :style="{backgroundImage : nodeFavicon(host)}"></div>
						</div>
						
						<div class="difficulty uppercase small-font" v-tooltip="'matrix_difficulty'">{{ getLocale('difficulty') }} {{matrix.level}}</div>
					</div>
					
					<div class="columns-12">
						<div class="flex">
							<div class="title hustle">Matrix</div>
						</div>
						
						<div class="current-vairus flex" v-if="currentVairus.length > 0">
							<div class="vairus-miniature" v-for="v in currentVairus" v-tooltip2="v.user" :style="{ 'background-image' : getVairusImage(v.vairus, 'base') }"></div>
							<div class="vairus-miniature" v-if="temp_miniature" :style="{ 'background-image' : getVairusImage(temp_miniature, 'base') }"></div>
						</div>
						
						<div class="wait-message lightestorange-color" v-else>{{ getLocale('waiting_matrix') }}</div>
					</div>
					
					<div class="icons flex">
						<tutorial-icon color="#FFC233" @clicked="setTutorial('matrix_info', -1, true)"/>
						<close-icon color="#FFC233"  @clicked="$emit('closematrixinfo')"/>
					</div>
				</div>
			
				<div class="select-mode">
					<div class="progress">
						<div class="bar-wrapper" :style="{transform : 'translateX(-'+(offset*2)+'%)'}">
							<div class="bar">
								<div class="base lightgreen-bkg" :style="{width : totalWidth}"></div>
								<div class="base lightorange-bkg" :style="{width : barWidth}"></div>
							</div>
							
							<div class="stages flex">
								<div class="stage" v-for="n in 50" :class="{enabled : currentStage >= n-1}" >
									<div class="icon lightestorange-border" v-tooltip2="(n == 2)? getLocale('first_reward') : '+'+(Math.floor(getRewardsMultiplier(n-1, 0)*100)-100)+'%'+' '+getLocale('rewards')"></div>
									<span>{{n-1}}</span>
								</div>
							</div>
						</div>
					</div>
					
						
					<div class="wrapper flex lightorange-border" :class="[matrix.assigned_vairus ? 'lightgreen-border lightgreen-color' : 'lightorange-border']">
						<div class="vairus columns-6 flex v-center">
							<div v-if="matrix.assigned_vairus">
								<vairus-card
									:vairus="matrix.assigned_vairus"
									:highlighted="false"
									:show_footer="false"
									:stats="true"
									:color="matrix.assigned_vairus ? 'green' : 'orange'"
								></vairus-card>
							</div>
							
							<div v-else>
								<div class="medium-font uppercase" v-if="matrix.score_boost == 1 && matrix.energy_left <= 0">{{getLocale('matrix_limit')}}</div>
								
								<vairus-card 
									v-else-if="matrix.selected_vairus"
									:vairus="matrix.selected_vairus"
									:highlighted="false"
									:show_footer="false"
									:stats="true"
									@clicked="$emit('choosevairusformatrix')"
									:color="matrix.assigned_vairus ? 'green' : 'orange'"
								></vairus-card>
								
								<empty-card v-else @clicked="$emit('choosevairusformatrix')" />
								
								<div class="start-button uppercase green-bkg bold" :class="{active : matrix.selected_vairus}" v-on:click="startMatrix">{{getLocale('start')}}</div>
							</div>
						</div>
						
						<div class="info columns-6 flex h-center">
							<div class="inner flex h-center">
							
								<div class="stats-column values" v-tooltip="'matrix_stat_info'" v-if="matrix.assigned_vairus || matrix.selected_vairus">
									<div  v-for="(value,stat) in ((matrix.assigned_vairus)? matrix.assigned_vairus.current_stats : matrix.selected_vairus.current_stats)" class="stat" :class="(stat == matrix.main_stat)? 'main' : (stat == matrix.secondary_stat)? 'secondary' : 'hidden'">
										<div class="icon"></div>
										<div class="text medium-font bold" >
											<div class="line" :class="[matrix.assigned_vairus ? 'lightgreen-border' : 'lightorange-border']"></div>
											{{(stat == matrix.main_stat)? primary_stat_preview : (stat == matrix.secondary_stat)? secondary_stat_preview : 0}}
										</div>
										<div class="index">{{(stat == matrix.main_stat)? '100%' : '50%' }}</div>
									</div>
								</div>
							
								<div v-else class="stats-column preview"  v-tooltip="'matrix_stat_info'">
									<div class="stat align-center row-padding">
										<div class="image lightorange-bkg">
											<img class="icon" v-bind:src="getImage(matrix.main_stat+'.svg')">
										</div>
										<div>{{getLocale(matrix.main_stat)}}</div>
										
										<div class="index">100%</div>
									</div>
									<div class="stat align-center row-padding">
										<div class="image lightorange-bkg">
											<img class="icon" v-bind:src="getImage(matrix.secondary_stat+'.svg')">
										</div>
										<div>{{getLocale(matrix.secondary_stat)}}</div>
										
										<div class="index">50%</div>
									</div>
								</div>
								
								<v-info 
									class="efficiency" 
									:color="matrix.assigned_vairus ? '#66FFD1' : '#FFC233'" 
									:text="Math.round(this.matrix.score_boost*100)+'%'" 
									v-tooltip="'matrix_efficiency'"
								/>
								<v-info 
									class="production-time" 
									:color="matrix.assigned_vairus ? '#66FFD1' : '#FFC233'" 
									:text="expirationTime" 
									v-tooltip="'matrix_timer'"
								/>
							</div>
						</div>
						
					</div>
				</div>
			</div>
			
			<div class="footer flex v-center">
				<div class="vairus-progress" v-tooltip2="getLocale('matrix_progress')+' '+rarityByLevel(matrix.level)">
					<svg xmlns="http://www.w3.org/2000/svg"  width="40" height="40" viewBox="-2 -2 44 44">
						<filter id="box-shadow" filterUnits="userSpaceOnUse">
							<feOffset result="offOut" in="SourceGraphic" dx="0" dy="0" />
							<feGaussianBlur result="blurOut" in="offOut" stdDeviation="2" />
							<feBlend in="SourceGraphic" in2="blurOut" mode="normal" />
						</filter>
						
						<radialGradient id="orange-gradient">
							<stop offset="10%" stop-color="black" />
							<stop offset="95%" stop-color="#4D2806" />
						</radialGradient>
						
						<circle 
							cx="20" cy="20" 
							r="20" stroke-width="0" fill="url('#orange-gradient')"
						/>
					
						<path 
							fill="none" stroke="black" 
							stroke-width="2" 
							:d="describeArc(0, 359, 20, 0)"
						></path>
						<path 
							fill="none" stroke="#FFC233" 
							filter="url(#box-shadow)"
							stroke-width="2" 
							:d="describeArc(0, (matrix.progress*3.6)/100, 20, 0)"
						></path>
					</svg>
					
					<div class="percent">{{Math.min(100, Math.floor((matrix.progress+newProgress)/100))}}%</div>
				</div>
					
				<div class="energy" v-tooltip="'matrix_left_tooltip'">
					{{ matrix.energy_left }} {{getLocale('matrix_left')}}
				</div>
			</div>
		</div>
	</div>
</template>


<script>
	import VairusCard from '../components/VairusCard.vue';
	import EmptyCard from '../components/EmptyCard.vue';
	import VInfo from '../components/VInfo.vue';
	import CloseIcon from '../components/CloseIcon.vue';
	import TutorialIcon from '../components/TutorialIcon.vue';
	import { commonMixin } from '../mixins/common.js';
	
	export default {
		props: ['matrix'],
		data: function () {
			return{
				current_time : Date.now(),
				start : false,
				temp_miniature : null,
			}
		},
		mixins: [commonMixin],
		mounted() {
			setInterval(function(){
				this.current_time = Date.now();
			}.bind(this), 1000);
			
			setTimeout(function(){
				this.start = true;
			}.bind(this), 0);
		},
		methods: {
			startMatrix(){
				if(this.matrix.selected_vairus != null){
					chrome.runtime.sendMessage({
						type : 'matrix_assign_vairus',
						data : {
							vairus_id : this.matrix.selected_vairus.unique_id,
							url : location.href
						}
					}, function(response){
						if(response.success){
							this.matrix.assigned_vairus = this.matrix.selected_vairus;
							this.temp_miniature = this.matrix.selected_vairus.vairus_type.id;
						}else{
							this.$emit('closematrixinfo');
						}
					}.bind(this));
				}
			},
			setTutorial(flag, update = false, fast = false){
				this.$store.commit('setTutorial', {
					flag : flag,
					update : update,
					fast : fast
				});
			},
			getRewardsMultiplier(stage, partial){
				var value = 0;
				for(var i=0; i<stage; i++){
					value+= Math.pow(1.15, Math.min(i, 12));
				}
				
				var next_value = Math.pow(1.15, Math.min(i, 12));
				
				return value + (next_value*partial/100);
			},
			rarityByLevel(level){
				switch(level){
					case 1: return this.getLocale('common');
					case 2: return this.getLocale('uncommon');
					case 3: return this.getLocale('rare');
					case 4: return this.getLocale('epic');
				}
			}
		},
		computed: {
			host(){
				return window.location;
			},
			expirationTime(){
				let seconds = Math.max(0, Math.floor((this.matrix.expiration - this.current_time)/1000));
				return Math.floor(seconds/60).toString().padStart(2, '0') +':'+ (seconds%60).toString().padStart(2, '0');
			},
			scoreBonus(){
				return this.primary_stat_value + this.secondary_stat_value;
			},
			primary_stat_value(){
				if(this.matrix.selected_vairus != null){
					let stats = this.matrix.selected_vairus.current_stats;
					return Math.floor(stats[this.matrix.main_stat].total*this.matrix.score_boost);
				}
				
				return 0;
			},
			secondary_stat_value(){
				if(this.matrix.selected_vairus != null){
					let stats = this.matrix.selected_vairus.current_stats;
					return Math.floor((stats[this.matrix.secondary_stat].total*this.matrix.score_boost)/2);
				}
				
				return 0;
				
			},
			primary_stat_preview(){
				if(this.matrix.selected_vairus != null){
					let stats = this.matrix.selected_vairus.current_stats;
					return Math.floor(stats[this.matrix.main_stat].total*this.matrix.score_boost);
				}
				
				if(this.matrix.assigned_vairus != null){
					let stats = this.matrix.assigned_vairus.current_stats;
					return Math.floor(stats[this.matrix.main_stat].total*this.matrix.score_boost);
				}
				
				return 0;
			},
			secondary_stat_preview(){
				if(this.matrix.selected_vairus != null){
					let stats = this.matrix.selected_vairus.current_stats;
					return Math.floor((stats[this.matrix.secondary_stat].total*this.matrix.score_boost)/2);
				}
				
				if(this.matrix.assigned_vairus != null){
					let stats = this.matrix.assigned_vairus.current_stats;
					return Math.floor((stats[this.matrix.secondary_stat].total*this.matrix.score_boost)/2);
				}
				
				return 0;
				
			},
			currentVairus(){
				if(!this.matrix.current_vairus) return [];
				
				let vairus = this.matrix.current_vairus.split(',');
				let users = this.matrix.current_users.split(',');
				
				return vairus.map(function(v, i){
					return { vairus : v, user : users[i]};
				});
			},
			currentStage(){
				if(!this.start) return 0;
				let starting_value = this.matrix.level*20;
				let stage = 0;
				let matrix_score = this.matrix.current_score+this.scoreBonus;
				
				while(matrix_score > Math.pow(1.1, stage)*starting_value){
					matrix_score-=Math.pow(1.1, stage)*starting_value;
					stage++;
				}
				return stage;
			},
			offset(){
				return Math.max(0, this.currentStage-2);
			},
			scoreRange(){
				let min = 0;
				let max = this.matrix.level*20;
				
				for(let i=0; i<this.currentStage; i++){
					min = max;
					max = min + Math.pow(1.1, i+1)*(this.matrix.level*20);
				}
				
				return [Math.floor(min), Math.floor(max)];
			},
			barWidth(){
				if(!this.start || this.matrix.current_score == null) return 0+'%';
				
				let partial = (((this.matrix.current_score)-this.scoreRange[0])*100) / (this.scoreRange[1]-this.scoreRange[0]);
				
				let width = (this.currentStage*2) + (2*partial/100);
				
				return width+'%';
			},
			totalWidth(){
				if(!this.start) return 0+'%';
				
				let partial = (((this.matrix.current_score+this.scoreBonus)-this.scoreRange[0])*100) / (this.scoreRange[1]-this.scoreRange[0]);
				
				let width = (this.currentStage*2) + (2*partial/100);
				
				return width+'%';
			},
			newProgress(){
				if(this.scoreBonus == 0)
					return 0;
					
				let partial = (((this.matrix.current_score+this.scoreBonus)-this.scoreRange[0])*100) / (this.scoreRange[1]-this.scoreRange[0]);
				let reward_multiplier = this.getRewardsMultiplier(this.currentStage, partial);
					
				let base_percent = 0.05*reward_multiplier;
				let contribution = this.scoreBonus/(this.matrix.current_score+this.scoreBonus);
				
				let vairus_chance = Math.min(0.5, base_percent*contribution);
				let new_progress = Math.floor(vairus_chance*10000);
				
				return new_progress;
			}
		},
		components: {
			VInfo,
			TutorialIcon,
			CloseIcon,
			VairusCard,
			EmptyCard
		}
	}
</script>


<style lang="scss" scoped>
	@import "../styles/variables";

	.matrix-info{
		position: fixed;
		top: 0;
		left: 0;
		width: 100%;
		height: 100%;
		z-index: 2147483647;
		
		> .inner{
			position: absolute;
			top: 50%;
			left: 50%;
			width: 700px;
			transform: translate(-50%,-50%);
			border-radius: 10px;
		    max-height: 95vh;
			max-width: 95vw;
			
			.container{
				padding: 20px;
			}
			
			.header{
				.node{
					display: inline-block;
					position: relative;
					width: 70px;
					height: 70px;
					margin-right: 50px;
					flex-shrink: 0;
					
					svg{
						position: absolute;
						left: 0;
						top: 0;
					}
					
					.inner{
						padding-top: 100%;
					
						.favicon{
							position: absolute;
							left: 35%;
							top: 35%;
							width: 30%;
							height: 30%;
							background-size: contain;
							pointer-events: none;
						}
					}
					
					.difficulty{
						margin-top: 10px;
						white-space: nowrap;
					}
				}
				
				.wait-message{
					min-height: 40px;
				}
					
				.close-icon{
					margin-left: 10px;
				}
			}
			
			.footer{
				padding: 5px 20px;
				background-color: #533C2F;
				border-bottom-left-radius: 10px;
				border-bottom-right-radius: 10px;
				
				.vairus-progress{
					display: flex;
					position: relative;
					width: 40px;
					align-items: center;
					
					.percent{
						position: absolute;
						left: 50%;
						top: 50%;
						transform: translate(-50%, -50%);
						text-align: center;
						font-size: 0.7em;
					}
				}
				
				.energy{
					margin-left: 25px;
				}
			}
			
			.progress{
				position: relative;
				margin-top: 20px;
				margin-bottom: 10px;
				overflow: hidden;
				padding-top: 5px;
				
				.stages{
					margin-top: 5px;
					
					.stage{
						position: relative;
						width: 2%;
						
						.icon{
							content: '';
							position: absolute;
							left: 4px;
							top: -13.5px;
							width: 5px;
							height: 5px;
							border-radius: 50%;
							border: 3px solid $lightestorange;
							box-sizing: content-box;
						}
						
						&.enabled .icon{
							border-color: $lightorange;
							background-color: $lightorange;
						}
						
						&:first-child{
							visibility: hidden;
						}
						
						span{
							height: 20px;
							width: 20px;
							display: block;
							border-radius: 50%;
							padding: 2px;
							text-align: center;
						}
						
						&:nth-child(2){
							.icon{
								border-width: 5px;
								left: 3px;
								top: -15.5px;
							}
						}
					}
				}
			
				.bar-wrapper{
					width: 1000%;
					transition: all 1s linear;
					
					.bar{
						position: relative;
						height: 6px;
						background-color: #4A3349;
						border: 2px solid black;
						overflow: hidden;
						
						.base{
							position: absolute;
							left: 0;
							top: 0;
							height: 100%;
							transition: width 0.1s;
							width: 0;
							transition: width 1s linear;
						}
					}
				}
			}
			
			
			.current-vairus{
				flex-wrap: wrap;
				max-height: 80px;
				overflow-y: auto;
				
				.vairus-miniature{
					width: 30px;
					height: 30px;
					margin-right: 10px;
					margin-top: 5px;
					background-color: white;
					background-size: cover;
						border-radius: 50%;
				}
			}
			
			.wrapper{
				padding: 0 15px;
				margin-bottom: 20px;
				margin-top: 30px;
				
				.vairus{
					padding: 20px;
					min-height: 300px;
					
					.empty-card,
					.vairus-card{
						margin: 0;
						max-width: 260px;
						z-index: 1;
					}
				}
				
				.start-button{
					position: absolute;
					color: black;
					height: 34.5px;
					line-height: 26px;
					padding: 5px 20px;
					bottom: -17.5px;
					left: 140%;
					right: -40%;
					cursor: pointer;
					transition: 0.5s all;
					transition-delay: 0.5s;
					
					&.active{
						left: -16px;
					}
				}
				
				.inner{
					width: 126px;
					background-color: rgba(255, 136, 0, 0.15);
					
					.efficiency{
						position: absolute;
						top: -18px;
						left: 50%;
						transform: translateX(-50%);
					}
					.production-time{
						position: absolute;
						bottom: -18px;
						left: 50%;
						transform: translateX(-50%);
					}
					
					.stats-column{
						display: flex;
						flex-direction: column;
						justify-content: center;
						width: 100%;
					
						.stat{
							position: relative;
							padding: 8px 0;
							text-align: center;
							
							&.hidden{
								visibility: hidden;
							}
								
							.image{
								display: inline-block;
								position: relative;
								width: 30px;
								height: 30px;
								border-radius: 50%;
								margin-top: 5px;

								img{
									position: absolute;
									left: 5px;
									top: 5px;
									right: 5px;
									bottom: 5px;
									width: 20px;
									height: 20px;
								}
							}
						
							.text{
								position: relative;
								height: 20px;
								line-height: 1;
								
								.line{
									content: '';
									position: absolute;
									right: 100%;
									top: calc(50% - 0.5px);
									height: 1px;
									width: 200px;
									z-index: 0;
								}
							}
							&:after{
								content: '';
								position: absolute;
								right: 0;
								top: 50%;
								transform: translateY(-50%);
								width: 0;
								height: 0;
								border-style: solid;
								border-width: 15px 15px 15px 0;
								border-color: transparent #23110C transparent transparent;
							}
							
							.index{
								position: absolute;
								left: calc(100% + 10px);;
								top: 50%;
								transform: translateY(-50%);
							}
						}
						
						&.values{
							.stat{
								display: flex;
								flex-direction: column;
								justify-content: center;
								height: 76px;
							}
						}
					}
				}
			}
			
			.actions{
				text-align: center;
				padding-top: 20px;
			}
		}
		
		&.assigned .inner .wrapper .inner .stats-column .stat .index,
		&.assigned .inner .wrapper .inner .stats-column .stat::after{
			margin-top: 0;
		}
	}
	
	@-webkit-keyframes run {
		0% { left: 0;}
		100%{ left : 100%;}
	}
	
	
	@media screen and (max-height: 680px) {
		.matrix-info > .inner{
			overflow-y: scroll;
			scrollbar-width: thin;
			scrollbar-color: $orange $black;
			
			&::-webkit-scrollbar {
				width: 8px;
			}
			&::-webkit-scrollbar-track {
				background-color: $black;
			}
			&::-webkit-scrollbar-thumb {
				background-color: $orange;
			}
		}
	}
</style>

<style lang="scss">

	@media screen and (max-width: 600px) {
		.matrix-info{
			.wrapper{
				.vairus{
					padding-left: 0 !important;
					padding-right: 0 !important;
				}
				.stats-column .stat{
					.index{
						left: 100% !important;
					}
					.line{
						display: none;
					}
					
					&.hidden{
						display: none !important;
					}
				} 
				
			} 
			
			.vairus-card{
				width: 175px;
				height: 250px;
				
				&.has-stats{
					width: 214px;
				}
				
				.vairus-stats .stat{
					padding: 5px 0;
					
					.image{
						width: 20px;
						height: 20px;
						
						img{
							left: 2px;
							top: 2px;
							right: 2px;
							bottom: 2px;
							width: 16px;
							height: 16px;
						}
					}
				}
			}
			
			.empty-card{
				width: 175px;
				height: 250px;
				
				.vairus-stats{
					padding: 0;
				}
			}
		}
	}
	
	@media screen and (max-width: 480px) {
		.matrix-info{
			.wrapper .inner{
				width: 80px !important;
				
				.stats-column{
					font-size: 0.7rem;
				}
			}
			
			.empty-card{
				width: 125px;
				height: 180px;
				
				.vairus-header .name{
					font-size: 25px;
				}
				.vairus-content{
					padding: 20px;
					padding-top: 0;
				}
				.vairus-content .wrapper .image .question-mark{
					font-size: 4rem !important;
				}
			}	
			
			.vairus-card{
				width: 145px !important;
				height: 180px;
				font-size: 0.7rem;
				
				.name{
					font-size: 25px;
				}
				
				.vairus-stats .stat{
					padding: 0;
				}
			}
		}
	}
</style>